/*
Scrivere un programma per la gestione delle operazioni presso una banca. Ogni  operazione  caratterizzata dalle seguenti informazioni: codice fiscale cliente, codice operazione (esempio RA273), tipo di operazione (1..4),  importo operazione, data dell'operazione.
Le operazioni  sono organizzate in memoria come una vettore di 70 elementi.
Nel programma e' presente un men caratterizzato dalle seguenti funzioni:
1) Inserimento di una nuova operazione;
2)Visualizzazione delle operazioni con un importo maggiore di un certo valore (chiedere il valore);
3) Ordinamento rispetto al codice fiscale del cliente;
4) Salvataggio su file delle operazioni di un certo tipo (chiedere il tipo).

All'avvio del programma i valori precedentemente salvate su file devono essere letti e copiati nel vettore mediante una funzione di inizializzazione del vettore. 

*/

#include <stdio.h>
#include <string.h>
struct operaz {
              char codicefiscale[20];
              char codiceoperazione[6];
              int tipo;
              float importo;
              char data[11];
              };
              
void inserimento(struct operaz *V,int *pn)
{struct operaz o;

   if(*pn<70)
          {printf("codice fiscale: ");
           scanf("%s",o.codicefiscale);
           printf("codice operazione: ");
           scanf("%s",o.codiceoperazione);
           printf("tipo operazione(1..4): ");
           scanf("%d",&o.tipo);
           printf("importo operazione: ");
           scanf("%f",&o.importo);
           printf("data operazione: ");
           scanf("%s",o.data);
          
           V[*pn]=o;
           (*pn)++;
          }
   else printf("vettore pieno");
}

void visualizza(struct operaz *V,int n)
{ int i;
  float importo;
  
  printf("visualizza operazioni maggiori di : ");
  scanf("%f",&importo);
  
  for(i=0;i<n;i++)
     if(V[i].importo>importo)
              { printf("codice fiscale: %s\n",V[i].codicefiscale);
                printf("codice operazione: %s\n",V[i].codiceoperazione);
                printf("tipo operazione: %d\n",V[i].tipo);
                printf("data operazione: %s\n\n",V[i].data);
              }
}              
 
void ordina(struct operaz *V,int n)
{ struct operaz temp;
  int sup,i;

  for(sup=n-1;sup>0;sup--)
    for(i=0;i<sup;i++)
       if(strcmp(V[i].codicefiscale,V[i+1].codicefiscale)>0)
                 {temp=V[i];
                  V[i]=V[i+1];
                  V[i+1]=temp;
                  }
                  
}                 
                
void salva(struct operaz *V,int n)
{ FILE *pf;
  int i,tipo;

  printf("tipo operazione(1..4): ");
  scanf("%d",&tipo);
  pf=fopen("banca.op","wb");
  if(pf!=NULL)
       {   for(i=0;i<n;i++)
              if(V[i].tipo==tipo)
                  fwrite(&V[i],sizeof(struct operaz),1,pf);
           fclose(pf);
       }
  else printf("errore");
} 

                             
void inizializza(struct operaz *V,int *pn)
{ FILE *pf;
  struct operaz o;
  int i;

  i=0;
  pf=fopen("banca.op","rb");
  if(pf!=NULL)
       {
          while(i<70 && fread(&o,sizeof(struct operaz),1,pf)>0)
              { V[i]=o;
                i++;
              }
          fclose(pf);
       }
  else printf("errore");
  *pn=i;
} 

           
main ()
{struct operaz A[70];
 int n,scelta;

 n=0;
 inizializza(A,&n);
 do{
    printf("\nscegli:\n1)inserimento\n2)visualizza operazioni maggiori di un importo\n3)ordina rispetto al codice fiscale\n4)salva\n0)fine\n: ");
    scanf("%d",&scelta);
    switch(scelta)      {
        case 1:  inserimento(A,&n);
                 break;
        case 2:  visualizza(A,n);
                 break;
        case 3:  ordina(A,n);
                 break;
        case 4:  salva(A,n);
                 break;
        default:;
       }
   } while(scelta!=0);
}   
